/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ActivityFile type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActivityFile{}

// ActivityFile struct for ActivityFile
type ActivityFile struct {
	Name string `json:"name"`
	Url string `json:"url"`
	MimeType string `json:"mime_type"`
}

// NewActivityFile instantiates a new ActivityFile object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActivityFile(name string, url string, mimeType string) *ActivityFile {
	this := ActivityFile{}
	this.Name = name
	this.Url = url
	this.MimeType = mimeType
	return &this
}

// NewActivityFileWithDefaults instantiates a new ActivityFile object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActivityFileWithDefaults() *ActivityFile {
	this := ActivityFile{}
	return &this
}

// GetName returns the Name field value
func (o *ActivityFile) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *ActivityFile) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *ActivityFile) SetName(v string) {
	o.Name = v
}

// GetUrl returns the Url field value
func (o *ActivityFile) GetUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Url
}

// GetUrlOk returns a tuple with the Url field value
// and a boolean to check if the value has been set.
func (o *ActivityFile) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Url, true
}

// SetUrl sets field value
func (o *ActivityFile) SetUrl(v string) {
	o.Url = v
}

// GetMimeType returns the MimeType field value
func (o *ActivityFile) GetMimeType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MimeType
}

// GetMimeTypeOk returns a tuple with the MimeType field value
// and a boolean to check if the value has been set.
func (o *ActivityFile) GetMimeTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MimeType, true
}

// SetMimeType sets field value
func (o *ActivityFile) SetMimeType(v string) {
	o.MimeType = v
}

func (o ActivityFile) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActivityFile) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["url"] = o.Url
	toSerialize["mime_type"] = o.MimeType
	return toSerialize, nil
}

type NullableActivityFile struct {
	value *ActivityFile
	isSet bool
}

func (v NullableActivityFile) Get() *ActivityFile {
	return v.value
}

func (v *NullableActivityFile) Set(val *ActivityFile) {
	v.value = val
	v.isSet = true
}

func (v NullableActivityFile) IsSet() bool {
	return v.isSet
}

func (v *NullableActivityFile) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActivityFile(val *ActivityFile) *NullableActivityFile {
	return &NullableActivityFile{value: val, isSet: true}
}

func (v NullableActivityFile) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActivityFile) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


